Search tool for EPUB e-books
You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 
tastytea 21cd476be0
Bump version of german translation.
6 months ago
cmake Don't generate checksums. We do that in the CI. 6 months ago
dist/termcolor Merge commit '6c33fb4dcebd5464d89ca3fb98bdf23847d81fbf' as 'dist/termcolor' 6 months ago
man Fix explanation for --json in man page. 6 months ago
src Fix nlohmann_json error with old versions. 6 months ago
tests Rename file names in search::matches to make it more clear. 6 months ago
translations Bump version of german translation. 6 months ago
.clang-format Add .clang-tify and .clang-format. 7 months ago
.clang-tidy Add .clang-tify and .clang-format. 7 months ago
.drone.yml Add nlohmann_json dependency. 6 months ago
.editorconfig Clean up .editorconfig. 6 months ago
.gitignore (Re-)generate .pot file by default, update readme. 7 months ago
AUTHORS Initial commit. 7 months ago
CMakeLists.txt Version bump 0.5.0. 6 months ago
CODE_OF_CONDUCT.adoc Initial commit. 7 months ago
CONTRIBUTING.adoc Mention --debug in bug reporting guideline. 6 months ago
CREDITS Update credits. 6 months ago
LICENSE Initial commit. 7 months ago
README.adoc Fix lowest tested nlohmann_json version. 6 months ago
screenshot.png Update screenshot. 6 months ago

README.adoc

epubgrep

epubgrep is a search tool for EPUB e-books. It does not operate on lines, but on whole files. All newlines will be replaced by spaces and HTML will be stripped. This means you can search for text spanning multiple lines and don’t have to worry about HTML tags in the text.

epubgrep is licensed under the AGPL-3.0-only. The bundled Termcolor is licensed under the BSD-3-Clause license.

Usage

Screenshot of epubgrep, showing the output of 2 book searches.

See man page for more information.

Install

Packaging status

Gentoo

sudo eselect repository enable guru
echo 'app-text/epubgrep' | sudo tee -a /etc/portage/package.accept_keywords/epubgrep
sudo emaint sync -r guru
sudo emerge -a app-text/epubgrep

Debian and Ubuntu

wget -O - https://tastytea.de/tastytea.asc | sudo apt-key add -
sudo add-apt-repository 'deb https://apt.schlomp.space/[code name] [code name] main'
sudo apt install epubgrep

Replace [code name] with the code name of your installation. Packages are available for buster (Debian 10), focal (Ubuntu 20.04) and bionic (Ubuntu 18.04).

Tip
If you get the error message that add-apt-repository was not found, install software-properties-common.

From source

Dependencies

  • Tested OS: Linux

  • C++ compiler with C++17 support (tested: GCC 8/10, clang 6/11)

  • CMake (at least: 3.12)

  • Boost (tested: 1.75.0 / 1.65.0)

  • gettext (tested: 0.21 / 0.19)

  • libarchive (tested: 3.5 / 3.2)

  • fmt (tested: 7.0 / 4.0)

  • AsciiDoc (tested: 9.0 / 8.6)

  • Termcolor (tested: 2.0) (If not found, the bundled version is used.)

  • pugixml (tested: 1.11 / 1.8)

  • nlohmann_json (tested: 3.9 / 2.1)

  • Optional

    • Tests: Catch (tested: 2.13 / 1.10)

Install dependencies in Debian or Ubuntu

Or distributions that are derived from Debian or Ubuntu. You will need at least Debian buster (10) or Ubuntu focal (20.04), unless you install a newer version of CMake.

sudo apt install build-essential cmake libboost-program-options-dev \
                 libboost-locale-dev libboost-regex-dev libboost-log-dev \
                 gettext libarchive-dev libfmt-dev asciidoc libpugixml-dev \
                 nlohmann-json-dev
Note
If nlohmann-json-dev can not be found, try nlohmann-json3-dev.

Get sourcecode

Release

Download the current release at schlomp.space.

Development version
git clone https://schlomp.space/tastytea/epubgrep.git

Compile

In a terminal, go to the directory where you unpacked / cloned the source code and then:

cmake -S . -B build
cmake --build build --parallel $(nproc --ignore=1)

To install, run sudo cmake --install build. To run the tests, run cd build/tests && ctest.

Tip
If you are using Debian or Ubuntu, or a distribution that is derived from these, you can run cpack -G DEB in the build directory to generate a .deb-file. You can then install it with apt install ./epubgrep-*.deb.
CMake options:
  • -DCMAKE_BUILD_TYPE=Debug for a debug build.

  • -DWITH_TESTS=YES if you want to compile the tests.

  • -DXGETTEXT_CMD=String The program to use instead of xgettext.

  • -DFALLBACK_BUNDLED=NO if you don’t want to fall back on bundled libraries.

How to contribute

Read the Code of Conduct.

Reporting bugs or suggesting enhancements

Before reporting a bug, please perform a search to see if the problem has already been reported. If it has, add a comment to the existing issue instead of opening a new one. Same for enhancements. It is helpful to re-run the command producing a bug with --debug and attaching the log file to the bug report. The log file of the last run is usually in ~/.local/state/epubgrep/epubgrep.log.

You can also contact me via E-Mail, XMPP or the Fediverse if you don’t want to open an account.

Pull requests

Please use similar coding conventions as the rest of the project. The basic rule to remember is to write code in the same style as the existing/surrounding code.

Add a copyright line with the year, your name and your email address to the files you edited. Add your name and email to AUTHORS. Unless you don’t want to.

You can also send me your patches via E-Mail, ideally using git send-email.

Translations

Creating a new translation

To create a new translation, copy translations/epubgrep.pot to translations/[LANGUAGE ABBREVIATION].po (Replace [LANGUAGE ABBREVIATION] with the correct abbreviation for your language, e.g. “es” if you are translating into Spanish or “pt_BR” if you are translating into Brazilian Portuguese). The pot-file is generated during the build process.

Open your new po file with your favourite text editor, (or you may prefer to use a translation catalog editor like Poedit), and first edit the header section of your file. You will need to replace the text in UPPERCASE with the correct values. The easiest way to work out how to do this is to compare it to another po file that already exists.

Updating your translation

When it is time to update your translation, first update your Git working directory. Then do the following:

cmake --build build
cd translations
msgmerge --update es.po epubgrep.pot

Then open your file and locate the strings that need updating. These will have an empty msgstr or will be marked “fuzzy”.

The translation guide is based on https://www.claws-mail.org/faq/index.php/Translator's_Information, licensed under GFDL-1.2-only.